package com.jiubang.commerce.chargelocker.holder;

import android.text.TextUtils;

/**
 * @author wubinqi
 */
public class HolderAdSdkThread {

	private Runnable mTask = null;
	private String mName = null;
	/**
	 * 是否使用线程池
	 */
	private boolean mUsePool = false;
	
	public HolderAdSdkThread(Runnable runnable) {
		mTask = runnable;
	}
	
	public HolderAdSdkThread(boolean usePool, Runnable runnable) {
		mTask = runnable;
		mUsePool = usePool;
	}
	
	public HolderAdSdkThread(String name, Runnable runnable) {
		mName = name;
		mTask = runnable;
	}
	
	public void start() {
		if (mUsePool && HolderAdSdkThreadExecutorProxy.execute(mTask)) {
			
		} else {
			Thread thread = new Thread(mTask);
			if (!TextUtils.isEmpty(mName)) {
				thread.setName(mName);
			}
			thread.start();
		}
	}
	
	public boolean isAlive() {
		return false;
	}
}
