package com.jiubang.commerce.chargelocker.holder;

import android.content.Context;
import android.os.Process;
import android.text.TextUtils;

/**
 * 使用协议103的统
 * {@literal http://wiki.3g.net.cn/pages/viewpage.action?pageId=17238489}
 * 
 * @author wubinqi
 */
public class HolderBaseSeq103OperationStatistic extends HolderAbsBaseStatistic {
	/** 操作统计-日志序列 */
	public static final int OPERATION_LOG_SEQ = 103;
	/** 功能id */
	public static final int FUN_ID = 455;
	/** 关联对象数据分隔�? */
	protected static final String ASSOCIATED_OBJ_SEPARATE = ";";
	/** 统计对象分隔�? */
	protected static final String SENDER_OBJ_SEPARATE = "#";
	// ===================操作代码====================
	/** 插数据线 */
	protected static final String OC_USB_IN = "in_data_line";
	/** 拔数据线 */
	protected static final String OC_USB_OUT = "pu_data_line";
	/** 请求逻辑 */
	protected static final String OC_DATA_REQ = "req_data";
	/** 逻辑下发 */
	protected static final String OC_DATA_NOTI = "noti_data";
	/** 充电锁屏展示 */
	protected static final String OC_SHOW_LOCKER = "f000_locker";
	/** 展示广告 */
	protected static final String OC_SHOW_AD = "ad_f000";
	/** 点击广告 */
	protected static final String OC_CLICK_AD = "ad_a000";
	/** 滑动解锁 */
	protected static final String OC_UNLOCK = "slide_unlock";
	/** 点击关闭按钮 */
	protected static final String OC_CLICK_CLOSE_BUTTON = "close_bu_cli";
	/** 关闭充电锁屏 */
	protected static final String OC_CLOSE_LOCKER = "close_locker";
	/** 左滑删除广告 */
	protected static final String OC_AD_DELETE = "ad_del";
	/** 充电锁屏展示�? 产品包名(获取展示权的产品) */
	protected static final String OC_RIGHT_SHOW = "right_show";
	/** 充电锁屏展示 产品包名(获取展示权的产品) */
	protected static final String OC_RIGHT_LOCKER_F000 = "right_locker_f000";

	/**
	 * 上传使用103协议的统计数�? 功能点ID||统计对象||操作代码||操作结果||入口||Tab分类||位置||关联对象||广告ID||备注
	 * 
	 * @param params
	 */
	protected static void uploadSqe103StatisticData(final StatisticParams params) {
		if (TextUtils.isEmpty(params.mOptionCode)) {
			return;
		}
		// 判断是否为输入法
		final boolean isGoKeyboard = params.mIsWeridProduct;
		new HolderAdSdkThread(new Runnable() {
			@Override
			public void run() {
				Process.setThreadPriority(Process.THREAD_PRIORITY_BACKGROUND);
				StringBuffer buffer = new StringBuffer();
				// 判断是否为输入法
				if (isGoKeyboard) {
					// 当前时间(输入法需要特殊处�?)
					buffer.append(System.currentTimeMillis());
					buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				}
				// 防止未传入功能ID
				int newFunId = params.mFunID;
				// 功能点ID
				buffer.append(newFunId);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// 统计对象(mapId)
				buffer.append(params.mSender);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// 操作代码
				buffer.append(params.mOptionCode);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// 操作结果-----0:未成�?,1:成功(默认成功)
				buffer.append(params.mOptionResults);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// 入口
				buffer.append(params.mEntrance);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// Tab分类
				buffer.append(params.mTabCategory);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// 位置
				buffer.append(params.mPosition);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// 关联对象
				buffer.append(params.mAssociatedObj);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// 广告ID
				buffer.append(params.mAId);
				buffer.append(STATISTICS_DATA_SEPARATE_STRING);
				// 备注
				buffer.append(params.mRemark);
				// 上传统计数据
				uploadStatisticData(params.mContext, OPERATION_LOG_SEQ,
						newFunId, buffer);

				HolderLogUtils.e(LOG_TAG, "uploadStatisticData( " + "/功能点ID : "
						+ newFunId + "   /统计对象(mapId) : " + params.mSender
						+ "   /操作代码 : " + params.mOptionCode + "   /操作结果 : "
						+ params.mOptionResults + "   /入口 : "
						+ params.mEntrance + "   /Tab分类 : "
						+ params.mTabCategory + "   /位置 : " + params.mPosition
						+ "   /关联对象 : " + params.mAssociatedObj + "   /广告ID : "
						+ params.mAId + "   /备注 : " + params.mRemark + " )");
			};
		}).start();
	}

	/**
	 * @author wubinqi
	 */
	static class StatisticParams {
		public final Context mContext;
		public final boolean mIsWeridProduct;
		/** 功能点ID */
		public final int mFunID;
		/** 操作结果 */
		public final int mOptionResults;
		/** 操作代码 */
		public final String mOptionCode;
		/** 统计对象 */
		public final String mSender;
		/** 入口 */
		public final String mEntrance;
		/** Tab分类 */
		public final String mTabCategory;
		/** 位置 */
		public final String mPosition;
		/** 关联对象 */
		public final String mAssociatedObj;
		/** 广告ID */
		public final String mAId;
		/** 备注 */
		public final String mRemark;

		public StatisticParams(Builder builder) {
			mContext = builder.mContext;
			mOptionResults = builder.mOptionResults;
			mOptionCode = builder.mOptionCode;
			mFunID = getFunctionId(builder.mOptionCode);
			mSender = builder.mSender;
			mEntrance = builder.mEntrance;
			mTabCategory = builder.mTabCategory;
			mPosition = builder.mPosition;
			mAssociatedObj = builder.mAssociatedObj;
			mAId = builder.mAId;
			mRemark = builder.mRemark;
			mIsWeridProduct = builder.mIsWeridProduct;
		}

		protected static int getFunctionId(String optionCode) {
			return FUN_ID;
		}

		/**
		 * @author wubinqi
		 */
		static class Builder {
			private final Context mContext;
			private boolean mIsWeridProduct;
			private int mOptionResults = 1;
			private final String mOptionCode;
			private String mSender;
			private String mEntrance;
			private String mTabCategory;
			private String mPosition;
			private String mAssociatedObj;
			private String mAId;
			private String mRemark;

			public Builder(Context context, String optionCode) {
				mContext = context.getApplicationContext();
				mOptionCode = optionCode;
			}

			/**
			 * @param sender
			 *            {@link StatisticParams#mSender}
			 * @return
			 */
			public Builder sender(String sender) {
				mSender = sender;
				return this;
			}

			/**
			 * @param optionResults
			 *            {@link StatisticParams#mOptionResults}
			 * @return
			 */
			public Builder optionResults(int optionResults) {
				mOptionResults = optionResults;
				return this;
			}

			/**
			 * @param entrance
			 *            {@link StatisticParams#mEntrance}
			 * @return
			 */
			public Builder entrance(String entrance) {
				mEntrance = entrance;
				return this;
			}

			/**
			 * @param entrance
			 *            {@link StatisticParams#mTabCategory}
			 * @return
			 */
			public Builder tabCategory(String tabCategory) {
				mTabCategory = tabCategory;
				return this;
			}

			/**
			 * @param position
			 *            {@link StatisticParams#mPosition}
			 * @return
			 */
			public Builder position(String position) {
				mPosition = position;
				return this;
			}

			/**
			 * @param associatedObj
			 *            {@link StatisticParams#mAssociatedObj}
			 * @return
			 */
			public Builder associatedObj(String associatedObj) {
				mAssociatedObj = associatedObj;
				return this;
			}

			/**
			 * @param aId
			 *            {@link StatisticParams#mAId}
			 * @return
			 */
			public Builder aId(String aId) {
				mAId = aId;
				return this;
			}

			/**
			 * @param remark
			 *            {@link StatisticParams#mRemark}
			 * @return
			 */
			public Builder remark(String remark) {
				mRemark = remark;
				return this;
			}

			/**
			 * @return 构建
			 */
			public StatisticParams build() {
				return new StatisticParams(this);
			}
		}
	}

	/***
	 * 充电锁展示权获取的结果统计（充电锁持有权�?
	 * 
	 * @param context
	 * @param packageName
	 * @param entrance
	 *            统计入口id
	 * @param success
	 *            占位成功：true、占位失败：false
	 * @另外 真正的统计对应的是�?�位置�??>position�? 1、成�? 0、失�?
	 */
	public static void uploadChargeLockerHolder(Context context,
			String packageName, String entrance, boolean success) {
		StatisticParams.Builder builder = new StatisticParams.Builder(context,
				OC_RIGHT_SHOW).sender(packageName).entrance(entrance)
				.position(success ? "1" : "0");
		// 输入法做特殊处理
		builder.mIsWeridProduct = "com.jb.emoji.gokeyboard"
				.equalsIgnoreCase(packageName);
		uploadSqe103StatisticData(builder.build());
	}

	/**
	 * 充电锁展示权，展示时（使用）的时候统计，占位成功后展示之统计�?�?
	 * 
	 * @param context
	 * @param packageName
	 * @param entrance
	 *            统计入口id
	 */
	public static void uploadChargeLockerHolderShow(Context context,
			String packageName, String entrance) {
		StatisticParams.Builder builder = new StatisticParams.Builder(context,
				OC_RIGHT_LOCKER_F000).sender(packageName).entrance(entrance);
		// 输入法做特殊处理
		builder.mIsWeridProduct = "com.jb.emoji.gokeyboard"
				.equalsIgnoreCase(packageName);
		uploadSqe103StatisticData(builder.build());
	}

}
