package com.jiubang.commerce.chargelocker.holder;

import android.util.Log;

/**
 * Log打印工具类
 *
 */
public class HolderLogUtils {

	public static final String TAG_SHOW_LOG = "showlog";
	//默认LogTag
	public static final String LOG_TAG = "ChargeLocker";
	//是否显示Log(true:显示;false:不显示)
	public static boolean sIS_SHOW_LOG = false;
	
	/**
	 * @param isPrint 是否打印log
	 */
	public static void printLog(boolean isPrint) {
		sIS_SHOW_LOG = isPrint;
	}
	
	/**
	 * debug级别Log信息
	 * @param logTag 日志Tag
	 * @param messageStr 要打印的日志信息
	 */
	public static void d(String logTag, String messageStr) {
		if (sIS_SHOW_LOG) {
			Log.d(logTag, messageStr);
		}
	}
	
	/**
	 * info级别Log信息
	 * @param logTag 日志Tag
	 * @param messageStr 要打印的日志信息
	 */
	public static void i(String logTag, String messageStr) {
		if (sIS_SHOW_LOG) {
			Log.i(logTag, messageStr);
		}
	}
	
	/**
	 * info级别Log信息
	 * @param tag
	 * @param msg
	 * @param classRef
	 */
	public static final void i(String tag, String msg, Object classRef) {
		if (sIS_SHOW_LOG) {
			Log.i(createTag(tag, classRef), msg);
		}
	}
	
	/**
	 * warn级别Log信息
	 * @param logTag 日志Tag
	 * @param messageStr 要打印的日志信息
	 */
	public static void w(String logTag, String messageStr) {
		if (sIS_SHOW_LOG) {
			Log.w(logTag, messageStr);
		}
	}
	
	/**
	 * warn级别Log信息
	 * @param logTag 日志Tag
	 * @param throwable 异常对象
	 */
	public static void w(String logTag, Throwable throwable) {
		if (sIS_SHOW_LOG) {
			Log.w(logTag, throwable);
		}
	}
	
	/**
	 * warn级别Log信息
	 * @param logTag 日志Tag
	 * @param messageStr 要打印的日志信息
	 * @param throwable 异常对象
	 */
	public static void w(String logTag, String messageStr, Throwable throwable) {
		if (sIS_SHOW_LOG) {
			Log.w(logTag, messageStr, throwable);
		}
	}
	
	/**
	 * error级别Log信息
	 * @param logTag 日志Tag
	 * @param messageStr 要打印的日志信息
	 */
	public static void e(String logTag, String messageStr) {
		if (sIS_SHOW_LOG) {
			Log.e(logTag, messageStr);
		}
	}
	
	/**
	 * error级别Log信息
	 * @param logTag 日志Tag
	 * @param messageStr 要打印的日志信息
	 * @param throwable 异常对象
	 */
	public static void e(String logTag, String messageStr, Throwable throwable) {
		if (sIS_SHOW_LOG) {
			Log.e(logTag, messageStr, throwable);
		}
	}
	
	/**
	 * v级别Log信息
	 * @param logTag 日志Tag
	 * @param messageStr 要打印的日志信息
	 */
	public static void v(String logTag, String messageStr) {
		if (sIS_SHOW_LOG) {
			Log.v(logTag, messageStr);
		}
	}
	
	/**
	 * v级别Log信息
	 * @param logTag 日志Tag
	 * @param messageStr 要打印的日志信息
	 * @param throwable 异常对象
	 */
	public static void v(String logTag, String messageStr, Throwable throwable) {
		if (sIS_SHOW_LOG) {
			Log.v(logTag, messageStr, throwable);
		}
	}
	
	public static final String getStackTraceString(Throwable tr) {
		return Log.getStackTraceString(tr);
	}
	
	/**
	 * 
	 * @param tag
	 * @param classRef
	 * @return
	 */
	private static final String createTag(String tag, Object classRef) {
		String tagRet = "com.jb@";
		try {
			if (classRef != null) {
				tagRet += classRef.getClass().getName();
				tagRet += "::";
				tagRet += new Exception().getStackTrace()[2].getMethodName();
				tagRet += "@";
			}
			tagRet += tag;
		} catch (Exception e) {

		}
		return tagRet;
	}
}
