package com.jiubang.commerce.chargelocker.holder;

import android.text.TextUtils;

/**
 * 遵从避让原则产品
 */
public class HolderProduct {
	/**
	 * packageName 包名
	 */
	public String mPackageName;
	/**
	 * 旧版有充电锁，但没有互相规避功能的最大版本号
	 */
	public int mMaxVersionCode;
	/** 旧版有充电锁，但没有互相规避功能的最小版本号 */
	public int mMinVersionCode;

	/***
	 * @param tagPackageName
	 * @param tagVersionCode
	 * @return 真正的检查，true是表示与旧版无功能冲突，通过；false表示与旧版功能冲突，不通过
	 */
	public boolean check(String tagPackageName, int tagVersionCode) {
		ChargeLockerHolder.log4i("check==>版本号检查:[目标" + tagVersionCode + ",最大"
				+ mMaxVersionCode + ",最小" + mMinVersionCode + "]");
		if (!TextUtils.isEmpty(tagPackageName)
				&& !TextUtils.isEmpty(mPackageName)
				&& mPackageName.equalsIgnoreCase(tagPackageName)
				&& mMaxVersionCode >= tagVersionCode
				&& mMinVersionCode <= tagVersionCode) {
			return false;
		}
		return true;
	}

	/**
	 * 产品信息工厂方法
	 * 
	 * @param productType
	 * @return
	 */
	public static HolderProduct produce(HolderProductType productType) {
		if (productType == null) {
			return new GOMsm();
		}
		switch (productType) {
		// case demoA:
		// return new ChargelockerdemoA();
		case ZeroZboost:
			return new ZeroZboost();
		case Alock:
			return new Alock();
		case GOKeyboard:
			return new GOKeyboard();
		case GOMsm:
			return new GOMsm();
		default:
			return new GOMsm();
		}
	}

//	/**
//	 * demoA
//	 * 
//	 * @author xiexingwu
//	 * 
//	 */
//	public static class ChargelockerdemoA extends HolderProduct {
//		public ChargelockerdemoA() {
//			super();
//			mPackageName = "com.commerce.chargelockerdemoA";
//			mMinVersionCode = 228;
//			mMaxVersionCode = 229;
//		}
//	}

	/**
	 * 极加速
	 * 
	 * @author xiexingwu
	 * 
	 */
	public static class ZeroZboost extends HolderProduct {
		public ZeroZboost() {
			super();
			mPackageName = "com.gto.zero.zboost";
			mMinVersionCode = 59;
			mMaxVersionCode = 64;
		}
	}

	/**
	 * 应用锁
	 * 
	 * @author xiexingwu
	 * 
	 */
	public static class Alock extends HolderProduct {
		public Alock() {
			super();
			mPackageName = "com.jiubang.alock";
			mMinVersionCode = 33;
			mMaxVersionCode = 41;
		}
	}

	/**
	 * GO输入法
	 * 
	 * @author xiexingwu
	 * 
	 */
	public static class GOKeyboard extends HolderProduct {
		public GOKeyboard() {
			super();
			mPackageName = "com.jb.emoji.gokeyboard";
			mMinVersionCode = 228;
			mMaxVersionCode = 235;
		}
	}

	/**
	 * GO短信
	 * 
	 * @author xiexingwu
	 * 
	 */
	public static class GOMsm extends HolderProduct {
		public GOMsm() {
			super();
			mPackageName = "com.jb.gosms";
			mMinVersionCode = 319;
			mMaxVersionCode = 326;
		}
	}

}
